<template>
    <div>
        <div class="alert alert-info text-center" role="alert" v-if="!cartItems.length">
            No items in the cart currently
        </div>
        <ul class="list-group" v-if="cartItems.length">
            <li class="list-group-item clearfix" v-for="item in cartItems" :key="item.id">
                <p class="float-left">{{item.productName}}</p>
                <div class="float-right clearfix">
                    <p class="float-left">Rs. {{item.price}} * </p>
                    <form class="form-group float-left" novalidate>
                        <input type="number"
                               min="1"
                               class="form-control text-center"
                               style="width: 100px"
                        :value="item.quantity"
                        @change="onChange($event, item.id)"/>
                    </form>
                    <button class="float-right btn btn-outline-danger" style="margin-left: 20px" @click="onDelete(item.id)"><i class="fa fa-trash"></i></button>
                </div>
            </li>
            <p style="text-align: end" class="alert alert-dark"  v-if="cartItems.length">Total Amount: Rs. {{totalAmount}} </p>
        </ul>
        <div class="alert alert-info text-center" role="alert" v-if="cartItems.length">
            <p>Finished shopping? Confirm order <router-link to="/shop/checkout"><a>here</a></router-link></p>
        </div>
    </div>
</template>

<script>
    export default {
        data() {
          return {
              price: [],
              totalAmount: 0
          }
        },
        computed: {
            cartItems() {
                return this.$store.getters.itemsInCart;
            }
        },
        created() {
            this.sum();
        },
        methods: {
            onChange(ev, id) {
                const foundIndex = this.cartItems.findIndex(item => item.id === id);
                if (foundIndex > -1) {
                    this.cartItems[foundIndex].quantity = ev.target.value;
                }
                this.$store.state.itemsInCart = this.cartItems;
                this.price = [];
                this.sum();
            },
            sum() {
                if (this.cartItems.length) {
                    for (let i = 0; i < this.cartItems.length; i++) {
                        this.price.push(this.cartItems[i].price * this.cartItems[i].quantity);
                    }
                    this.totalAmount = this.price.reduce(this.addFunc);
                    this.$store.commit('setTotalAmount', this.totalAmount);
                }
            },
            addFunc(total, num) {
                return total + num;
            },
            onDelete(id) {
                const foundIndex = this.cartItems.findIndex(item => item.id === id);
                const currentPrice = this.cartItems.filter(item => item.id === id);
                this.totalAmount -= (currentPrice[0].price * currentPrice[0].quantity);
                this.$store.commit('setTotalAmount', this.totalAmount);
                if (foundIndex > -1) {
                    this.cartItems.splice(foundIndex, 1);
                }
                this.$store.state.itemsInCart = this.cartItems;
            }
        }
    }
</script>